/*
 * @(#)ZReverseEnumeration.java
 *
 * Copyright 2001 by Intelligent Technology Inc. All rights reserved.
 *
 * Reverse Enumeration
 */
package jp.co.iti.fagot.util;

import java.util.Enumeration;
import java.util.Vector;

import jp.co.iti.fagot.util.ZDebug;
/**
 * 逆順 Enumeration
 *
 * @author  福島康治
 * @version 1.01 2002/10/23
 */
public class ZReverseEnumeration implements Enumeration {

	/**
	 * コンストラクタ
	 * @param vec 元となるベクター
	 */
	public ZReverseEnumeration(Vector vec) {
	mVector = vec;
	}

	/**
	 * エレメントが存在するか？
	 */
	public boolean hasMoreElements() {
	return mCount < mVector.size();
	}

	/**
	 * 次のエレメントの取得
	 */
	public Object nextElement() {
	if (mCount < mVector.size()) {
		return mVector.elementAt(mVector.size()-(++mCount));
	}
	return null;
	}

	//## アトリビュート ###############################################
	/**
	 * 元となるベクター
	 */
	protected Vector mVector = null;

	/**
	 * 現在カウント
	 */
	protected int mCount = 0;
}
